
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `IOArg': argument for `aprintf', etc.                         //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

struct IOArg {
  const Frame* aValue ;
  void* aData ;
  int aLen ;

  int iValue ;

  IOArg() {}

  IOArg(const Frame* value, void* data, const int len) :
      aValue(value), aData(data), aLen(len) {}

  IOArg(const int value) : iValue(value) {}
} ;


void gprintf(char* _control, ...) ;
void gscanf(char* _control, ...) ;

//void aprintf(char* control, ...) ;
//void ascanf(char* control, ...) ;

void gfprintf(FILE* fd, char* _control, ...) ;
void gfscanf(FILE* fd, char* _control, ...) ;

//void afprintf(FILE* fd, char* control, ...) ;
//void afscanf(FILE* fd, char* control, ...) ;

FILE* gfopen(char* name, char* mode) ;
void gfclose(FILE* fd) ;

// aprintf

void aprintf(char* control, IOArg* args) ;

inline void aprintf(char* control, IOArg arg1) {
  IOArg args [1] ;
  args [0] = arg1 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control, IOArg arg1, IOArg arg2) {
  IOArg args [2] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control, IOArg arg1, IOArg arg2, IOArg arg3) {
  IOArg args [3] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4) {
  IOArg args [4] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5) {
  IOArg args [5] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6) {
  IOArg args [6] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6, IOArg arg7) {
  IOArg args [7] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  args [6] = arg7 ;
  aprintf(control, args) ;
}

inline void aprintf(char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6, IOArg arg7, IOArg arg8) {
  IOArg args [8] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  args [6] = arg7 ;
  args [7] = arg8 ;
  aprintf(control, args) ;
}

// afprintf

void afprintf(FILE* fd, char* control, IOArg* args) ;

inline void afprintf(FILE* fd, char* control, IOArg arg1) {
  IOArg args [1] ;
  args [0] = arg1 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control, IOArg arg1, IOArg arg2) {
  IOArg args [2] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control, IOArg arg1, IOArg arg2, IOArg arg3) {
  IOArg args [3] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4) {
  IOArg args [4] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5) {
  IOArg args [5] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6) {
  IOArg args [6] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6, IOArg arg7) {
  IOArg args [7] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  args [6] = arg7 ;
  afprintf(fd, control, args) ;
}

inline void afprintf(FILE* fd, char* control,
                    IOArg arg1, IOArg arg2, IOArg arg3, IOArg arg4,
                    IOArg arg5, IOArg arg6, IOArg arg7, IOArg arg8) {
  IOArg args [8] ;
  args [0] = arg1 ;
  args [1] = arg2 ;
  args [2] = arg3 ;
  args [3] = arg4 ;
  args [4] = arg5 ;
  args [5] = arg6 ;
  args [6] = arg7 ;
  args [7] = arg8 ;
  afprintf(fd, control, args) ;
}

